<?php

declare(strict_types=1);

namespace Drupal\slots_test\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a slots element test form.
 */
final class SlotsFormTest extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId(): string {
    return 'slots_form_test';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state): array {
    $form['slots'] = [
      '#type' => 'slots',
      '#title' => $this->t('Slots'),
      '#plugin_manager' => 'plugin.manager.condition',
      '#default_value' => [],
    ];

    $form['actions'] = [
      '#type' => 'actions',
      'submit' => [
        '#type' => 'submit',
        '#value' => $this->t('Send'),
      ],
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state): void {
    $form_state->cleanValues();

    if (\Drupal::moduleHandler()->moduleExists('devel')) {
      \Drupal::service('devel.dumper')->message($form_state->getValue('slots'));
    }
    else {
      \Drupal::messenger()->addStatus(print_r($form_state->getValue('slots'), TRUE));
    }
  }

}
